# fm10k-dump

Utility that allows dumping the SPI Flash Non-Volatile Memory of the FM10000 family of cards.

## Requirements
* GCC >= 4.4.0 or clang
* make
* [fm10k kernel module](https://git.gammaspectra.live/FM10K/fm10k) compiled with UIO.
  * `# cd src && make clean && make -j $(nproc) CONFIG_UIO=1 && make install CONFIG_UIO=1`
  * `# rmmod fm10k && modprobe uio && modprobe fm10k`
  * If this works an UIO device (`/dev/uio0`) will exist. If not, check your bifurcation settings and/or whether the slot supports 16x PCIe 3.0

## Compilation
* `$ make clean && make`
* You can specify whether to use gcc or clang this way: `$ make CC=gcc` / `$ make CC=clang`
* An executable named `./fm10k-dump` should now exist.

## Usage example
* If the chip on the card is known to the tool, it'll set the image size to match. Alternatively it will use the platform minimum of 8Mbit.
* `# ./fm10k-dump /dev/uio0 outputImage.bin`
* You can also force the image/chip size: `# ./fm10k-dump /dev/uio0 outputImage.bin 32`

## License
* BSD-3-Clause
* See [fm10k-dump.c](fm10k-dump.c) header for more information.